<?
/******************************************************************************

Funktionen fr den Caupo Shop

Sprache		: PHP3
Copyright	: http://www.caupo.de/shop/licence.txt
Author(en) 	: Andreas Kempf
Datum		: 1999-07-02
Version		: 1.0
Datei		: functions_admin.inc.php3

*******************************************************************************/

/******************************************************************************
returnwert			function				argumente
-------------------------------------------------------------------------------
1/0					FncWriteArtikel 		$svArtikel_Art, $svArtikel_Nr, $svArtikel_Name,
											$svBeschreibung, $nPreisA, $svImage_Small
1/0					FncDeleteArtikel 		$nArtikel_ID
$saEinArtikel		FncGetArtikel 			$nArtikel_ID

					FncGetArtikelDB			$svSort
					FncGetAdressDB			$svSort

					FncBestellStatistik 	$svSortField

Anmerkung: 1/0 = wahr / unwahr
******************************************************************************/

// Setze Variable fr diese Funktionsbibliothek
$bFncFile["admin"] = true;

// Lese funktionsbibliotheken ein
if (!$bFncFile["general"])
	include ("../inc/functions_general.inc.php3");
if (!$bFncFile["adress"])
	include ("../inc/functions_adress.inc.php3");
if (!$bFncFile["ccv"])
	include ("../inc/functions_ccv.inc.php3");
if (!$bFncFile["shop"])
	include ("../inc/functions_shop.inc.php3");

/******************************************************************************
 Function 	: FncWriteArtikel
 Arguments  : $svArtikel_Art, $svArtikel_Nr, $svArtikel_Name, $svBeschreibung,
			  $svAktion, $nPreisA, $nPreisB, $nPreisC, $nPreisD, $nPreisE, $nMwst,
			  $svImage_Small,	$svImage_Big
 Description: Schreibt Artikel-Daten als neuen Datensatz in die Artikeltabelle
 Returns  	: 1/0
 Echos		: -
 Templates 	: -
 Date		: 1999-07-05
 Author		: andreas kempf aka 'amalesh' <ak@living-source.com>
*******************************************************************************/

function 	FncWriteArtikel
			(	$svArtikel_Art,
				$svArtikel_Nr,
				$svArtikel_Name,
				$svBeschreibung,
				$svAktion,
				$nPreisA,
				$nPreisB,
				$nPreisC,
				$nPreisD,
				$nPreisE,
				$nMwst,
				$svImage_Small,
				$svImage_Big
			)
{

	include ("../inc/var_sql.inc.php3");
	$connectionID = FncOpenDatabase ();

	// Dezimaltrenner: bei komma-eingabe im preis punkt setzen
	$nPreisA = ereg_replace(",",".",$nPreisA);
	$nPreisB = ereg_replace(",",".",$nPreisB);
	$nPreisC = ereg_replace(",",".",$nPreisC);
	$nPreisD = ereg_replace(",",".",$nPreisD);
	$nPreisE = ereg_replace(",",".",$nPreisE);

	$svBeschreibung = ereg_replace("'","\'",$svBeschreibung);
	$svArtikel_Name = ereg_replace("'","\'",$svArtikel_Name);


	if (strlen($nPreisB) == 0)
	{	$nPreisB = 0;
	}
	if (strlen($nPreisC) == 0)
	{	$nPreisC = 0;
	}
	if (strlen($nPreisD) == 0)
	{	$nPreisD = 0;
	}
	if (strlen($nPreisE) == 0)
	{	$nPreisE = 0;
	}

	// Tabellenfelder fr insertstring
	$saInsertField[0] = "Artikel_Art, ";
	$saInsertField[1] = "Artikel_Nr, ";
	$saInsertField[2] = "Artikel_Name, ";
	$saInsertField[3] = "Beschreibung, ";
	$saInsertField[4] = "Artikel_Aktion, ";
	$saInsertField[5] = "Preis_A, ";
	$saInsertField[6] = "Preis_B, ";
	$saInsertField[7] = "Preis_C, ";
	$saInsertField[8] = "Preis_D, ";
	$saInsertField[9] = "Preis_E, ";
	$saInsertField[10] = "mwst, ";
	$saInsertField[11] = "Image_Small, ";
	$saInsertField[12] = "Image_Big ";

	// Bilde 1. Teil des Insertstring
	$i=0;
	while ($i <= count($saInsertField))
	{	$svInsertField .= $saInsertField[$i];
		$i++;
	}

	// Bilde kompletten Insert-String
	$svSQL = "insert into $cfgTabArtikel ($svInsertField) values ('$svArtikel_Art', '$svArtikel_Nr', '$svArtikel_Name', '$svBeschreibung', '$svAktion', $nPreisA, $nPreisB, $nPreisC, $nPreisD, $nPreisE, $nMwst, '$svImage_Small', '$svImage_Big')";
	if (DEBUG) echo "\n<!-- debug: $svSQL -->\n";

	// Trage Datensatz ein
	$result = mysql_query( $svSQL, $connectionID);

	if ($result)
	{	return "1";
	}
	else
	{	return "0";
	}
};
/******************************************************************************
 Function 	: FncUpdateArtikel
 Arguments  : $nID, $svArtikel_Art, $svArtikel_Nr, $svArtikel_Name, $svBeschreibung,
			  $svAktion, $nPreisA = "0", $nPreisB = "0", $nPreisC = "0", $nPreisD = "0",
			  $nPreisE = "0", $nMwst = "0", $svImage_Small, $svImage_Big
 Description: ndert bestehende Artikel-Daten in der Artikeltabelle
 Returns  	: 1/0
 Echos		: -
 Templates 	: -
 Date		: 1999-04-08
 Author		: andreas kempf aka 'amalesh' <ak@living-source.com>
*******************************************************************************/
function FncUpdateArtikel
			(	$nID,
				$svArtikel_Art,
				$svArtikel_Nr,
				$svArtikel_Name,
				$svBeschreibung,
				$svAktion,
				$nPreisA = "0",
				$nPreisB = "0",
				$nPreisC = "0",
				$nPreisD = "0",
				$nPreisE = "0",
				$nMwst = "0",
				$svImage_Small,
				$svImage_Big
			)
{

	include ("../inc/var_sql.inc.php3");
	$connectionID = FncOpenDatabase ();

	// Bilde kompletten Insert-String
	$svSQL = "update $cfgTabArtikel set Artikel_Art='$svArtikel_Art', Artikel_Nr='$svArtikel_Nr', Artikel_Name='$svArtikel_Name', Beschreibung='$svBeschreibung', Artikel_Aktion='$svAktion', Preis_A=$nPreisA, Preis_B=$nPreisB, Preis_C=$nPreisC, Preis_D=$nPreisD, Preis_E=$nPreisE, mwst=$nMwst, Image_Small='$svImage_Small', Image_Big='$svImage_Big' where ID=$nID";
	if (DEBUG) echo "\n<!-- debug: $svSQL -->\n";

	// Trage Datensatz ein
	$result = mysql_query( $svSQL, $connectionID);

	if ($result)
	{	return "1";
	}
	else
	{	return "0";
	}
};

/******************************************************************************
 Function 	: FncDeleteArtikel
 Arguments  : $nArtikel_ID
 Description: Lscht Artikel
 Returns  	: 1/0
 Echos		: -
 Templates 	: -
 Date		: 1999-04-08
 Author		: andreas kempf aka 'amalesh' <ak@living-source.com>
*******************************************************************************/
function FncDeleteArtikel ($nArtikel_ID)
{
	include ("../inc/var_sql.inc.php3");
	
	$connectionID = FncOpenDatabase ();
	$svSQL = "delete from $cfgTabArtikel where ID=$nArtikel_ID";
	if (DEBUG) echo "\n<!-- debug: $svSQL -->\n";

	$result = mysql_query($svSQL,$connectionID);

	$nRows = mysql_affected_rows($result);

	return $nRows;
	
};

/******************************************************************************
 Function 	: FncGetArtikelDB
 Arguments  : $svSort = "ID",$nPos="0",$svValue="0",$svArtikelArt="0",$svAktion="0"
 Description: Stellt alle Artikel als Tabelle dar und erlaubt editieren
 Returns  	: 1/0
 Echos		: Tabelle der Artikel
 Templates 	: -
 Date		: 1999-06-30
 Author		: andreas kempf aka 'amalesh' <ak@living-source.com>
*******************************************************************************/
function FncGetArtikelDB ($svSort = "ID",$nPos="0",$svValue="0",$svArtikelArt="0",$svAktion="0")
{
	include ("../inc/var_sql.inc.php3");
	include ("../inc/var_general.inc.php3");
	
	$connectionID = FncOpenDatabase ();

	// Bilde SQL-Sring
	$svSQL 		= "select $cfgTabArtikelFelder 
					from $cfgTabArtikel";			// Start
	// Sortierung
	if ($cfgSortOrder)	// Wenn angegeben
	{	$svSQLOrder = " order by $svSort,$cfgSortOrder";
	}

	$svSQL .= FncSQLSearchString ($svValue,$svArtikelArt,$svAktion);	// Search
	
	if (DEBUG) echo "\n<!-- debug: $svSQL -->\n";

	// Fhre SQL-Query aus
	$result = mysql_query( "$svSQL",$connectionID);

	// Baue Tabelle
	echo "<table border=1 cellpadding=1 cellspacing=0><tr>\n";
	echo "<td>Copy</td>\n";	
	$x=0;
	while ($field = mysql_fetch_field($result))
	{	$Fieldname = strtolower($field->name);
		// Finde heraus, welches feld id ist, um das anzuzeigen
		if ($Fieldname == "id")
		{	$Fieldname = "Edit";
			$nIsId = $x;		// Setze wert
		}
		// Finde heraus, welches feld timestamp ist
		if ($Fieldname == "timestamp")
		{	$nTsId = $x;		// Setze wert
		}
		// Finde heraus, welches feld thumbnail hat
		if ($Fieldname == "image_small")
		{	$nImageId = $x;		// Setze wert
		}

		echo "<td><A HREF=\"artikel_tabelle.php3?svSort=$field->name\"><strong>$Fieldname</strong></a></td>"; 

		$x++;
	} 
	// Ende kopfzeile
	echo "<td>Aktion</td></tr>\n";

	while ($row = mysql_fetch_array($result))
	{	echo    "<tr>"; 
		echo "<td><a href=\"artikel_edit.php3?nID=$row[0]&svAction=copy\">$row[0]</a></td>\n";
		for($i=0; $i < mysql_num_fields($result); $i++)
		{	
 		if ($i == $nTsId)	// Wenn timestamp
 		{	$row[$i] = FncChangeTimestamp ($row[$i],"YYYY-MM-DD hh:mm:ss");
 			echo "<td nowrap><font size=\"-1\">$row[$i]</font></td>";
 		}
 		elseif ($i == $nImageId && $row[$i] != "") // Wenn image
 		{	$saImSize = GetImageSize("../images/$row[$i]");
 			$svImageSmall = "<img src=\"../images/$row[$i]\" width=\"$saImSize[0]\" height=\"$saImSize[1]\" alt=\"Thumbnail\" border=\"0\">";
 			echo "<td nowrap>$svImageSmall<br><font size=\"-1\">$row[$i]</font></td>";
 		}
 		elseif ($i == $nIsId)	// Wenn id
 		{	echo "<td><a href=\"artikel_edit.php3?svAction=edit&nID=$row[0]\">$row[$i]</a></td>\n";
 		}
 		else
 		{	$row[$i] = nl2br($row[$i]);
 			echo "<td valign=top nowrap>$row[$i]</td>";
			}
		}
		echo "<td><a href=\"artikel_del.php3?nID=$row[0]\">Lschen</a></td>\n";
		echo "</tr>\n"; 
	} 

	echo "</table><br>\n";			

	// Gebe result oder 0 zurck
	if ($result)
	{	return "1";
	}
	else
	{	return "0";
	}

};

/******************************************************************************
 Function 	: FncGetAdressDB
 Arguments  : -
 Description: Stellt alle Adressen als Tabelle dar und erlaubt editieren
 Returns  	: 1/0
 Echos		: Tabelle der Adressen
 Templates 	: -
 Date		: 1999-04-14
 Author		: andreas kempf aka 'amalesh' <ak@living-source.com>
*******************************************************************************/
function FncGetAdressDB ()
{
	include ("../inc/var_sql.inc.php3");

	// Tabellenfelder der Adress-Datenbank
	$saTableField[0] = "id";
	$saTableField[1] = "anrede";
	$saTableField[2] = "vorname";
	$saTableField[3] = "nachname";
	$saTableField[4] = "firma";
	$saTableField[5] = "strasse_nr";
	$saTableField[6] = "plz";
	$saTableField[7] = "ort";
	$saTableField[8] = "land";
	$saTableField[9] = "telefon";
	$saTableField[10] = "telefax";
	$saTableField[11] = "email";
	$saTableField[12] = "kunden_nr";
	$saTableField[13] = "la_anrede";
	$saTableField[14] = "la_vorname";
	$saTableField[15] = "la_nachname";
	$saTableField[16] = "la_firma";
	$saTableField[17] = "la_strasse_nr";
	$saTableField[18] = "la_plz";
	$saTableField[19] = "la_ort";
	$saTableField[20] = "la_land";
	$saTableField[21] = "la_telefon";
	$saTableField[22] = "la_telefax";
	$saTableField[23] = "la_email";
	$saTableField[24] = "kreditk_typ";
	$saTableField[25] = "kreditk_nr";
	$saTableField[26] = "kreditk_gueltdate";
	$saTableField[27] = "kreditk_gueltcheck";
	$saTableField[28] = "bank";
	$saTableField[29] = "blz";
	$saTableField[30] = "konto_nr";
	$saTableField[31] = "bestellart";
	$saTableField[32] = "timestamp";


	$connectionID = FncOpenDatabase ();
	$svSQL = "select * from $cfgTabAdressen";
	if (DEBUG) echo "\n<!-- debug: $svSQL -->\n";

	// Fhre SQL-Query aus
	$result = mysql_query( "$svSQL",$connectionID);

	// Baue Tabelle
	echo "<table border=1 cellpadding=1 cellspacing=0><tr>\n";
	$i=0;
	while ($i <= count($saTableField))
	{	// Tabellenkopf
		echo "<td>$saTableField[$i]</td>\n";
		$i++;
	}
	echo "</tr>\n";	

	while ($saEineAdresse = mysql_fetch_array($result))
	{	
		echo "<tr>\n";
		for($i=0; $i < mysql_num_fields($result); $i++)
		{	
			// Baue Tabellenzeile
			// Wenn id=0, dann edit-anchor
			if ($i == 0)
			{	echo "<td><a href=\"adress_edit.php3?nID=$saEineAdresse[$i]\">$saEineAdresse[$i]</a></td>\n";
			}
			else
			{	echo "<td>$saEineAdresse[$i]</td>\n";
			}
		}

		echo "<td><a href=\"adress_tabelle.php3?Del=1&nID=$saEineAdresse[0]\">Lschen</a></td>\n";
		echo "</tr>\n";
	}
	echo "</table>\n";			

	// Gebe result oder 0 zurck
	if ($result)
	{	return "1";
	}
	else
	{	return "0";
	}


};


/******************************************************************************
 Function 	: FncBestellStatistik
 Arguments  : $svSortField
 Description: Bildet Top-Ten-Liste von Bestellungen
 Returns  	: -
 Echos		: -
 Templates 	: statistik_table_head.tpl,statistik_table_row.tpl
 Date		: 1999-05-19
 Author		: andreas kempf aka 'amalesh' <ak@living-source.com>
*******************************************************************************/
function FncBestellStatistik ($svSortField)
{
		include ("../inc/var_sql.inc.php3");

		$connectionID = FncOpenDatabase ();
		
		// Hole zuerst Artikel_Id's
		$svSQL 	= "select distinct $svSortField from $cfgTabBestell order by $svSortField";
		$result = mysql_query( $svSQL,$connectionID);
		$nRows 	= mysql_num_rows($result);
		$x=0;
		while ($x < $nRows)
		{	$nSortField[$x] = $x+1;
			$svSQ[$x] = "select sum(artikel_menge * preis) as summe from $cfgTabBestell where $svSortField=$nSortField[$x]";
			$result = mysql_query( "$svSQ[$x]",$connectionID);
			$nSumme[$x] = mysql_result( $result, "summe");
			
			settype ($nSumme[$x],"double");

			$x++;
		}

		// Bubblesort
        for($i = sizeof($nSumme); $i >= 1; $i--)
        {	for($j = 1; $j <= $i; $j++)
            {   if($nSumme[$j-1] > $nSumme[$j])
                {   $t = $nSumme[$j-1];
                    $t2 = $nSortField[$j-1];
                    $nSumme[$j-1] = $nSumme[$j];
                    $nSortField[$j-1] = $nSortField[$j];
                    $nSumme[$j] = $t;
                    $nSortField[$j] = $t2;
                }
            }
        }
		
		// Weise Namen zu und lade template fr Statistik-Tabellen-Kopf
		if (strtolower($svSortField) == "artikel_id")
		{	$svBezeichnung = "Name des Artikels";
		}
		if (strtolower($svSortField) == "kunden_id")
		{	$svBezeichnung = "Name des Kunden";
		}
		include ("../templates/statistik_table_head.tpl");
		
		// Hole Bezeichnungen aus SQL-Tabellen
		$x=count($nSumme);
		$nRang = 1;
		while ($x != 0)
		{
			// Hole die Mengen-Summen aus der Datenbank
			$connectionID = FncOpenDatabase ();
			$svSQL = "select sum(artikel_menge) as sum_menge from $cfgTabBestell where $svSortField=$nSortField[$x]";
			if (DEBUG) echo "\n<!-- debug: $svSQL -->\n";
			$result = mysql_query($svSQL,$connectionID);
			$nSummeMenge[$x] = mysql_result( $result, "sum_menge");

			// Hole die Namen
			if (strtolower($svSortField) == "artikel_id")
			{	$svName = FncGetArtikelField ($nSortField[$x], "Artikel_Name");
			}
			if (strtolower($svSortField) == "kunden_id")
			{	$svName = FncGetAdressField ($nSortField[$x], "Nachname");
			}

			// Weise Namen zu und lade template fr Statistik-Tabellen-Zeile
			if ($nSumme[$x] > 0)
			{	$nSum = sprintf ("%4.2f", $nSumme[$x]);
				$nSumMenge = sprintf ("%4.0f", $nSummeMenge[$x]);
				include ("../templates/statistik_table_row.tpl");
			}
			$nRang++;
			$x--;
		}
		echo "</table>\n";

}

// EOF
?>