<?

/******************************************************************************

Adress-Funktionen fr den Caupo Shop

Sprache		: PHP3
Copyright	: http://www.caupo.de/shop/licence.txt
Author(en) 	: Andreas Kempf
Datum		: 1999-07-20
Version		: 1.0
Datei		: functions_adress.inc.php3

*******************************************************************************/

/******************************************************************************
returnwert			function				argumente
-------------------------------------------------------------------------------
$saEineAdresse		FncGetAdress 			$nKunden_ID
$svValue/0			FncShowAdressField 		$nKunden_ID, $svField
$svValue			FncGetAdressField 		$nKunden_ID, $svField
$nKunden_ID			FncGetKundenNr 			$svVorname, $svNachname, $svOrt
$nKunden_ID			FncCheckKunde 			$svNachname, $svPassword
1/0					FncCheckAdressInput		$svAnrede, $svVorname, $svNachname, $svFirma,
											$svStrasse_Nr, $svPLZ, $svOrt, $svTelefon,
											$svEmail, $svKreditk_Typ, $svKreditk_Nr,
											$svPassword, $svPassword2
1/0					FncWriteKunde 			$svAnrede, $svVorname, $svNachname,
											$svStrasse_Nr, $svPLZ, $svOrt, $svEmail,
											$svKreditk_Typ, $svKreditk_Nr, $svKreditk_Guelt,
											$svBank, $svBLZ, $svKonto_Nr
1/0					FncUpdateKunde 			$nID, $svAnrede, $svVorname, $svNachname,
											$svStrasse_Nr, $svPLZ, $svOrt, $svEmail,
											$svKreditk_Typ, $svKreditk_Nr, $svKreditk_Guelt,
											$svBank, $svBLZ, $svKonto_Nr
1/0					FncDeleteKunde 			$svVorname, $svNachname, $nKunden_ID


Anmerkung: 1/0 = wahr / unwahr

******************************************************************************/

// Setze Variable fr diese Funktionsbibliothek
$bFncFile["adress"] = true;


/******************************************************************************
 Function 	: FncGetAdress
 Arguments  : $nKunden_ID
 Description: Holt alle Felder fr eine Adresse aus Adress-Datenbank und gibt sie als array zurck
 Returns  	: $saEineAdresse
 Echos		: -
 Templates 	: -
 Date		: 1999-04-14
 Author		: andreas kempf aka 'amalesh' <ak@living-source.com>
*******************************************************************************/

function FncGetAdress ($nKunden_ID)
{

	// Wenn ID nicht 0, wird ausgefhrt
	if ($nKunden_ID != 0)
	{
		include ("inc/var_sql.inc.php3");

		// Tabellenfelder der Adress-Datenbank
		$saTableField[0] = "ID";
		$saTableField[1] = "Anrede";
		$saTableField[2] = "Vorname";
		$saTableField[3] = "Nachname";
		$saTableField[4] = "Strasse_Nr";
		$saTableField[5] = "PLZ";
		$saTableField[6] = "Ort";
		$saTableField[7] = "Email";
		$saTableField[8] = "Kreditk_Typ";
		$saTableField[9] = "Kreditk_Nr";
		$saTableField[10] = "Kreditk_Guelt";
		$saTableField[11] = "Bank";
		$saTableField[12] = "BLZ";
		$saTableField[13] = "Konto_Nr";
		$saTableField[14] = "Timestamp";

		$connectionID = FncOpenDatabase ();
		$svSQL = "select * from $cfgTabAdressen where ID = $nKunden_ID";
		if (DEBUG) echo "\n<!-- debug: $svSQL -->\n";

		//Fhre SQL-Query aus
		$result = mysql_query( "$svSQL",$connectionID);
		$saEineAdresse = mysql_fetch_array($result);

	}
	
	// Gebe result oder 0 zurck
	if ($saEineAdresse)
	{	return $saEineAdresse;
	}
	else
	{	return "0";
	}

}

/******************************************************************************
 Function 	: FncShowAdressField
 Arguments  : $nKunden_ID, $svField
 Description: Zeigt einzelnes Feld aus Adress-Datenbank
 Returns  	: 0 if no success
 Echos		: $svValue if success
 Templates 	: -
 Date		: 1999-04-15
 Author		: andreas kempf aka 'amalesh' <ak@living-source.com>
*******************************************************************************/

function FncShowAdressField ($nKunden_ID, $svField)
{
	error_reporting(0);
	//Wenn ID nicht 0, wird ausgefhrt
	if ($nKunden_ID != 0)
	{
		include ("inc/var_sql.inc.php3");

		$connectionID = FncOpenDatabase ();
		$svSQL = "select $svField from $cfgTabAdressen where ID = $nKunden_ID";

		$result = mysql_query($svSQL,$connectionID);
		$svValue = mysql_result($result, 0, $svField);

	}

	//Gebe result oder 0 aus und zurck
	if ($svValue)
	{	echo $svValue;
	}
	else
	{	return "0";
	}

}

/******************************************************************************
 Function 	: FncGetAdressField
 Arguments  : $nKunden_ID, $svField
 Description: Holt einzelnes Feld aus Adress-Datenbank
 Returns  	: $svValue
 Echos		: -
 Templates 	: -
 Date		: 1999-04-15
 Author		: andreas kempf aka 'amalesh' <ak@living-source.com>
*******************************************************************************/

function FncGetAdressField ($nKunden_ID, $svField)
{
	error_reporting(0);
	//Wenn ID nicht 0, wird ausgefhrt
	if ($nKunden_ID != 0)
	{
		include ("inc/var_sql.inc.php3");

		$connectionID = FncOpenDatabase ();
		$svSQL = "select $svField from $cfgTabAdressen where ID = $nKunden_ID";

		$result = mysql_query($svSQL,$connectionID);
		$svValue = mysql_result($result, 0, $svField);

	}

	//Gebe result oder 0 aus und zurck
	if ($svValue)
	{	return $svValue;
	}
	else
	{	return "0";
	}

};

/******************************************************************************
 Function 	: FncGetKundenNr
 Arguments  : $svVorname, $svNachname, $svOrt
 Description: Holt Kunden-Nummer aufgrund von Vorname, Nachname, Ort
 Returns  	: $svValue
 Echos		: -
 Templates 	: -
 Date		: 1999-04-15
 Author		: andreas kempf aka 'amalesh' <ak@living-source.com>
*******************************************************************************/

function FncGetKundenNr ($svVorname, $svNachname, $svOrt)
{
	error_reporting(0);
	include ("inc/var_sql.inc.php3");
	$connectionID = FncOpenDatabase ();
	$svSQL = "select ID from $cfgTabAdressen where vorname='$svVorname' and nachname='$svNachname' and ort='$svOrt'";

	if (DEBUG) echo "\n<!-- debug: $svSQL -->\n";

	$result = mysql_query( "$svSQL",$connectionID);
	$svValue = @mysql_result($result, 0, "ID");
	
	//Memory freigeben 
	mysql_free_result($result);
	mysql_close($connectionID);


	if ($svValue)
	{	return $svValue;
	}
	else
	{	return "0";
	}

};

/******************************************************************************
 Function 	: FncCheckKunde
 Arguments  : $svNachname, $svPassword
 Description: Holt Kunden-Nummer aufgrund von Nachname, Passwort
 Returns  	: $svValue
 Echos		: -
 Templates 	: -
 Date		: 1999-04-15
 Author		: andreas kempf aka 'amalesh' <ak@living-source.com>
*******************************************************************************/

function FncCheckKunde ($svNachname, $svPassword)
{
	include ("inc/var_sql.inc.php3");
	$connectionID = FncOpenDatabase ();
	$svSQL = "select ID from $cfgTabAdressen where nachname='$svNachname' and password='$svPassword'";

	if (DEBUG) echo "\n<!-- debug: $svSQL -->\n";

	$result = mysql_query( "$svSQL",$connectionID);
	$svValue = @mysql_result($result, "ID");
	
	if ($svValue)
	{	return $svValue;
	}
	else
	{	return "0";
	}

};

/******************************************************************************
 Function 	: FncCheckAdressInput
 Arguments  : $svAnrede,$svVorname,$svNachname,$svFirma,$svStrasse_Nr,
			  $svPLZ,$svOrt,$svTelefon,$svEmail,$svKreditk_Typ,$svKreditk_Nr,
			  $svPassword,$svPassword2
 Description: berprft Input-Felder der Adressen
 Returns  	: 1/0
 Echos		: Error-Meldungen
 Templates 	: -
 Date		: 1999-04-21
 Author		: andreas kempf aka 'amalesh' <ak@living-source.com>
*******************************************************************************/

function FncCheckAdressInput
			(	$svAnrede,
				$svVorname,
				$svNachname,
				$svFirma,
				$svStrasse_Nr,
				$svPLZ,
				$svOrt,
				$svTelefon,
				$svEmail,
				$svKreditk_Typ,
				$svKreditk_Nr,
				$svPassword,
				$svPassword2
			)
			
{

	//Lese Fehler-Texte und funktionen zur verifizierung ein
	include ("inc/var_err.inc.php3");

	$bFieldOk = 1;

	$svValue = FncCheckKunde ($svNachname, $svPassword);
	if ($svValue != 0)
	{	echo $svErrAdr16;
		$bFieldOk = 0;
	}

	//berprfe alle bentigten felder auf inhalt
	if ($svPassword != $svPassword2)
	{	echo $svErrAdr00;
		$bFieldOk = 0;
	}

	if (strlen($svPassword) == 0)
	{	echo $svErrAdr01;
		$bFieldOk = 0;
	}

	if ( strlen ( $svNachname) == 0)
	{	echo $svErrAdr02;
		$bFieldOk = 0;
	}

	if ( $svAnrede == "Firma" && (strlen($svFirma) == 0))
	{	echo $svErrAdr14;
		$bFieldOk = 0;
	}

	if (strlen ($svStrasse_Nr) == 0)
	{	echo $svErrAdr03;
		$bFieldOk = 0;
	}

	if (strlen ($svPLZ) == 0)
	{	echo $svErrAdr04;
		$bFieldOk = 0;
	}

	//berprfe, ob PLZ nur aus Zahlen besteht
	if (strlen ($svPLZ) != 0)
	{	$bPLZ = FncOnlyDigits ($svPLZ);
		if ($bPLZ == 0)
		{	echo $svErrAdr05;
			$bFieldOk = 0;
		}
	}

	if (strlen ($svOrt) == 0)
	{	echo $svErrAdr06;
		$bFieldOk = 0;
	}

	if (strlen ($svTelefon) == 0)
	{	echo $svErrAdr07;
		$bFieldOk = 0;
	}

	if 	($svKreditk_Typ != "-1" || $svKreditk_Nr != "-1")
	{	$bCheck = FncCC ($svKreditk_Typ,$svKreditk_Nr);
		if ($bCheck == "0")
		{	echo $svErrAdr15;
			$bFieldOk = 0;
		}
	}

	if (strlen ($svEmail) == 0)
	{	echo $svErrAdr08;
		$bFieldOk = 0;
	}

	if (strlen ($svEmail) != 0)
	{	$bEmail = FncCheckEmail ($svEmail);
		if ($bEmail == 0)
		{	echo $svErrAdr09;
			$bFieldOk = 0;
		}
	}

	return $bFieldOk;
	
};

/******************************************************************************
 Function 	: FncWriteKunde
 Arguments  : $svAnrede,$svVorname,$svNachname,$svFirma,$svStrasse_Nr,$svPLZ,
			  $svOrt,$svLand,$svTelefon,$svTelefax,$svEmail,$svKunden_Nr,
			  $svLa_Anrede,$svLa_Vorname,$svLa_Nachname,$svLa_Firma,$svLa_Strasse_Nr,
			  $svLa_PLZ,$svLa_Ort,$svLa_Land,$svLa_Telefon,$svLa_Telefax,
			  $svLa_Email,$svKreditk_Typ,$svKreditk_Nr,$svKreditk_GueltDate,
			  $nKreditk_Gueltcheck,$svBank,$svBLZ,$svKonto_Nr,$svBestellArt,$svPassword
 Description: Schreibt Kunden-Daten
 Returns  	: 1/0
 Echos		: -
 Templates 	: -
 Date		: 1999-04-08
 Author		: andreas kempf aka 'amalesh' <ak@living-source.com>
*******************************************************************************/

function	FncWriteKunde
			(	$svAnrede,
				$svVorname,
				$svNachname,
				$svFirma,
				$svStrasse_Nr,
				$svPLZ,
				$svOrt,
				$svLand,
				$svTelefon,
				$svTelefax,
				$svEmail,
				$svKunden_Nr,
				$svLa_Anrede,
				$svLa_Vorname,
				$svLa_Nachname,
				$svLa_Firma,
				$svLa_Strasse_Nr,
				$svLa_PLZ,
				$svLa_Ort,
				$svLa_Land,
				$svLa_Telefon,
				$svLa_Telefax,
				$svLa_Email,
				$svKreditk_Typ,
				$svKreditk_Nr,
				$svKreditk_GueltDate,
				$nKreditk_Gueltcheck,
				$svBank,
				$svBLZ,
				$svKonto_Nr,
				$svBestellArt,
				$svPassword
			)

{
	include ("inc/var_sql.inc.php3");
	$connectionID = FncOpenDatabase ();

	$svTimeStamp = Date ("YmdHis");

	$nKreditk_Gueltcheck = FncCC ($svKreditk_Typ,$svKreditk_Nr);

	//Tabellenfelder fr insertstring
	//Tabellenfelder der Adress-Datenbank
	$saInsertField[0 ] = "anrede, ";
	$saInsertField[1 ] = "vorname, ";
	$saInsertField[2 ] = "nachname, ";
	$saInsertField[3 ] = "firma, ";
	$saInsertField[4 ] = "strasse_nr, ";
	$saInsertField[5 ] = "plz, ";
	$saInsertField[6 ] = "ort, ";
	$saInsertField[7 ] = "land, ";
	$saInsertField[8 ] = "telefon, ";
	$saInsertField[9 ] = "telefax, ";
	$saInsertField[10] = "email, ";
	$saInsertField[11] = "kunden_nr, ";
	$saInsertField[12] = "la_anrede, ";
	$saInsertField[13] = "la_vorname, ";
	$saInsertField[14] = "la_nachname, ";
	$saInsertField[15] = "la_firma, ";
	$saInsertField[16] = "la_strasse_nr, ";
	$saInsertField[17] = "la_plz, ";
	$saInsertField[18] = "la_ort, ";
	$saInsertField[19] = "la_land, ";
	$saInsertField[20] = "la_telefon, ";
	$saInsertField[21] = "la_telefax, ";
	$saInsertField[22] = "la_email, ";
	$saInsertField[23] = "kreditk_typ, ";
	$saInsertField[24] = "kreditk_nr, ";
	$saInsertField[25] = "kreditk_gueltdate, ";
	$saInsertField[26] = "kreditk_gueltcheck, ";
	$saInsertField[27] = "bank, ";
	$saInsertField[28] = "blz, ";
	$saInsertField[29] = "konto_nr, ";
	$saInsertField[30] = "bestellart, ";
	$saInsertField[31] = "timestamp, ";
	$saInsertField[32] = "password";


	//Bilde 1. Teil des Insertstring
	$i=0;
	while ($i <= count($saInsertField))
	{	$svInsertField = $svInsertField	. $saInsertField[$i];
		$i++;
	}

	//Bilde kompletten Insert-String
	$svSQL = "insert into $cfgTabAdressen ($svInsertField) values ('$svAnrede','$svVorname','$svNachname','$svFirma','$svStrasse_Nr','$svPLZ','$svOrt','$svLand','$svTelefon','$svTelefax','$svEmail','$svKunden_Nr','$svLa_Anrede','$svLa_Vorname','$svLa_Nachname','$svLa_Firma','$svLa_Strasse_Nr','$svLa_PLZ','$svLa_Ort','$svLa_Land','$svLa_Telefon','$svLa_Telefax','$svLa_Email','$svKreditk_Typ','$svKreditk_Nr','$svKreditk_GueltDate',$nKreditk_Gueltcheck,'$svBank','$svBLZ','$svKonto_Nr','$svBestellArt', '$svTimeStamp', '$svPassword')";
	if (DEBUG) echo "\n<!-- debug: $svSQL -->\n";


	//Trage Datensatz ein
	$result = mysql_query( $svSQL, $connectionID);

	if ($result)
	{	return "1";
	}
	else
	{	return "0";
	}


};

/******************************************************************************
 Function 	: FncUpdateKunde
 Arguments  : $nID,$svAnrede,$svVorname,$svNachname,$svFirma,$svStrasse_Nr,$svPLZ,
			  $svOrt,$svLand,$svTelefon,$svTelefax,$svEmail,$svKunden_Nr,
			  $svLa_Anrede,$svLa_Vorname,$svLa_Nachname,$svLa_Firma,$svLa_Strasse_Nr,
			  $svLa_PLZ,$svLa_Ort,$svLa_Land,$svLa_Telefon,$svLa_Telefax,
			  $svLa_Email,$svKreditk_Typ,$svKreditk_Nr,$svKreditk_GueltDate,
			  $nKreditk_Gueltcheck,$svBank,$svBLZ,$svKonto_Nr,$svBestellArt,$svPassword
 Description: ndert Kunden-Daten
 Returns  	: 1/0
 Echos		: -
 Templates 	: -
 Date		: 1999-04-08
 Author		: andreas kempf aka 'amalesh' <ak@living-source.com>
*******************************************************************************/

function 	FncUpdateKunde
			(	$nID,
				$svAnrede,
				$svVorname,
				$svNachname,
				$svFirma,
				$svStrasse_Nr,
				$svPLZ,
				$svOrt,
				$svLand,
				$svTelefon,
				$svTelefax,
				$svEmail,
				$svKunden_Nr,
				$svLa_Anrede,
				$svLa_Vorname,
				$svLa_Nachname,
				$svLa_Firma,
				$svLa_Strasse_Nr,
				$svLa_PLZ,
				$svLa_Ort,
				$svLa_Land,
				$svLa_Telefon,
				$svLa_Telefax,
				$svLa_Email,
				$svKreditk_Typ,
				$svKreditk_Nr,
				$svKreditk_GueltDate,
				$nKreditk_Gueltcheck,
				$svBank,
				$svBLZ,
				$svKonto_Nr,
				$svBestellArt,
				$svPassword
			)

{
	include ("inc/var_sql.inc.php3");
	$connectionID = FncOpenDatabase ();

	$svTimeStamp = Date ("YmdHis");

	//Bilde kompletten Insert-String
	$svSQL = "update $cfgTabAdressen set Anrede='$svAnrede',Vorname='$svVorname',Nachname='$svNachname',Firma='$svFirma',Strasse_Nr='$svStrasse_Nr',PLZ='$svPLZ',Ort='$svOrt',Land='$svLand',Telefon='$svTelefon',Telefax='$svTelefax',Email='$svEmail',Kunden_Nr='$svKunden_Nr',La_Anrede='$svLa_Anrede',La_Vorname='$svLa_Vorname',La_Nachname='$svLa_Nachname',La_Firma='$svLa_Firma',La_Strasse_Nr='$svLa_Strasse_Nr',La_PLZ='$svLa_PLZ',La_Ort='$svLa_Ort',La_Land='$svLa_Land',La_Telefon='$svLa_Telefon',La_Telefax='$svLa_Telefax',La_Email='$svLa_Email',Kreditk_Typ='$svKreditk_Typ',Kreditk_Nr='$svKreditk_Nr',Kreditk_GueltDate='$svKreditk_GueltDate',Kreditk_Gueltcheck=$nKreditk_Gueltcheck,Bank='$svBank',BLZ='$svBLZ',Konto_Nr='$svKonto_Nr',BestellArt='$svBestellArt', password='$svPassword', timestamp='$svTimeStamp' where ID=$nID";
	if (DEBUG) echo "\n<!-- debug: $svSQL -->\n";

	//Trage Datensatz ein
	$result = mysql_query( $svSQL, $connectionID);

	if ($result)
	{	return "1";
	}
	else
	{	return "0";
	}


};

/******************************************************************************
 Function 	: FncDeleteKunde
 Arguments  : $nKunden_ID
 Description: Lscht Kunden
 Returns  	: 1/0
 Echos		: -
 Templates 	: -
 Date		: 1999-04-07
 Author		: andreas kempf aka 'amalesh' <ak@living-source.com>
*******************************************************************************/

function FncDeleteKunde ($nKunden_ID)
{
	include ("inc/var_sql.inc.php3");

	$connectionID = FncOpenDatabase ();
	$svSQL = "delete from $cfgTabAdressen where ID=$nKunden_ID";
	if (DEBUG) echo "\n<!-- debug: $svSQL -->\n";

	$result = mysql_query( "$svSQL",$connectionID);

	if ($result)
	{	return "1";
	}
	else
	{	return "0";
	}

};

?>