<?

/******************************************************************************
Funktionen fr den Caupo Shop

Sprache		: PHP3
Copyright	: http://www.caupo.de/shop/licence.txt
Author(en) 	: Andreas Kempf
Datum		: 1999-07-20
Version		: 1.0
Datei		: functions_shop.inc.php3

*******************************************************************************/

/******************************************************************************
returnwert			function				argumente
-------------------------------------------------------------------------------
$svValue			FncGetArtikelField 		$nArtikel_ID, $svField
					FncShowArtikelField 	$nArtikel_ID, $svField
$svValue 			FncGetArtikelID 		$svArtikel_Nr
1/0 				FncCheckAdressInput		$svAnrede, $svVorname, $svNachname,
											$svStrasse_Nr, $svPLZ, $svOrt,
											$svTelefon, $svEmail, $svPassword, $svPassword2
$saEinArtikel		FncGetArtikel 			$nArtikel_ID

$saArtikelArt		FncArtikelArtSelectOption		
					FncArtikelAktionSelectOption ()
					
1/0					FncAddArtikelToBasket 	$VID, $nArtikel_Menge, $nArtikel_ID
1/0					FncDeleteBasket 		$VID
1/0					FncDeleteBasketArtikel 	$VID, $nArtikel_ID
1/0					FncUpdateBasketMenge 	$VID, $nArtikel_ID, $nArtikel_Menge
$nSum				FncGetBasketSum 		$VID
$nSum				FncGetBasketMwstIncl	$VID
$nSum				FncGetBasketMwstExcl	$VID
					FncBasketArtikelTabelle $VID
1/0					FncExecuteBestell 		$nKunden_ID, $VID, $svKundenEmail
					FncDisplayBasketArtikel	$saBasketArtikel

1/0					FncExistKunde 			$nKunden_ID
1/0					FncAddArtikelToBestell 	$VID, $nAnzahl, $nArtikel_ID

$svValue			FncSQLSearchString 		$svValue="0",$svArtikelArt="0",$svArtikelAktion="0"
					FncShopArtikelTabelle	$svArtikel_Art, $VID, $svPreisTyp, $svAktion
					FncShopEinArtikel		$svArtikel_Nr, $VID
1/0					FncShopArtikelSearch 	$VID, $svValue

Anmerkung: 1/0 = wahr / unwahr


******************************************************************************/

// berprfe debug-status
include ("inc/var_general.inc.php3");

if ($cfgDebug == 1)
	define(DEBUG,1);	// Setze auf 1
else
	define(DEBUG,0);	// Setze auf 0

// Setze Variable fr diese Funktionsbibliothek
$bFncFile["shop"] = true;

// Lese funktionsbibliotheken ein
if (!$bFncFile["general"])
	include ("inc/functions_general.inc.php3");
if (!$bFncFile["adress"])
	include ("inc/functions_adress.inc.php3");
if (!$bFncFile["ccv"])
	include ("inc/functions_ccv.inc.php3");

/******************************************************************************
 Function 	: 
 Arguments  : $nArtikel_ID, $svField
 Description: Holt einzelnes Feld aus Artikel-Datenbank und gibt es als return-wert zurck
 Returns  	: $svValue / 0
 Echos		: -
 Templates 	: -
 Date		: 1999-04-08
 Author		: andreas kempf aka 'amalesh' <ak@living-source.com>
*******************************************************************************/

function FncGetArtikelField ($nArtikel_ID, $svField)
{
	if ($nArtikel_ID != 0)
	{
		include ("inc/var_sql.inc.php3");

		$connectionID = FncOpenDatabase ();
		$svSQL = "select $svField from $cfgTabArtikel where ID = $nArtikel_ID";

		if (DEBUG) echo "\n<!-- debug: $svSQL -->\n";

		// Fhre SQL-Query aus
		$result = @mysql_query($svSQL,$connectionID);
		$svValue = @mysql_result($result, $svField);

	}	

	// Gebe result oder 0 zurck
	if ($svValue)
	{	return $svValue;
	}
	else
	{	return "0";
	}

};

/******************************************************************************
 Function 	: FncShowArtikelField
 Arguments  : $nArtikel_ID, $svField
 Description: Holt einzelnes Feld aus Artikel-Datenbank und zeigt es an
 Returns  	: 0 bei mierfolg
 Echos		: $svValue (bei erfolg)
 Templates 	: 
 Date		: 1999-04-08
 Author		: andreas kempf aka 'amalesh' <ak@living-source.com>
*******************************************************************************/

function FncShowArtikelField ($nArtikel_ID, $svField)
{
	if ($nArtikel_ID != 0)
	{
		include ("inc/var_sql.inc.php3");

		$connectionID = FncOpenDatabase ();
		$svSQL = "select $svField from $cfgTabArtikel where ID = $nArtikel_ID";

		if (DEBUG) echo "\n<!-- debug: $svSQL -->\n";

		/* Fhre SQL-Query aus */
		$result = @mysql_query($svSQL,$connectionID);
		$svValue = @mysql_result($result, $svField);
	}	

	// Gebe result oder 0 aus und zurck
	if ($svValue)
	{	echo $svValue;
	}
	else
	{	return "0";
	}
};

/******************************************************************************
 Function 	: FncGetArtikelID
 Arguments  : $svArtikel_Nr
 Description: Holt Artikel-ID und gibt es als return-wert zurck
 Returns  	: $svValue
 Echos		: -
 Templates 	: -
 Date		: 1999-04-07
 Author		: andreas kempf aka 'amalesh' <ak@living-source.com>
*******************************************************************************/

function FncGetArtikelID ($svArtikel_Nr)
{
	include ("inc/var_sql.inc.php3");

	$connectionID = FncOpenDatabase ();
	$svSQL = "select ID from $cfgTabArtikel where Artikel_Nr='$svArtikel_Nr'";
	if (DEBUG) echo "\n<!-- debug: $svSQL -->\n";

	$result = @mysql_query($svSQL,$connectionID);
	$svValue = @mysql_result($result, 0, "ID");

	if (strlen($svValue) != 0)
	{	return $svValue;
	}
	else
	{	return "0";
	}
};

/******************************************************************************
 Function 	: FncGetArtikel
 Arguments  : $nArtikel_ID
 Description: Holt alle Felder fr einen Artikel aus Artikel-Datenbank und gibt sie als array zurck
 Returns  	: $saEinArtikel
 Echos		: -
 Templates 	: -
 Date		: 1999-04-07
 Author		: andreas kempf aka 'amalesh' <ak@living-source.com>
*******************************************************************************/

function FncGetArtikel ($nArtikel_ID)
{
	include ("inc/var_sql.inc.php3");

	$connectionID = FncOpenDatabase ();

	$svSQL = "select * from $cfgTabArtikel where ID = $nArtikel_ID";

	/* Fhre SQL-Query aus */
	$result = @mysql_query( $svSQL,$connectionID);
	$saEinArtikel = @mysql_fetch_array($result);
	if (DEBUG) echo "\n<!-- debug: $svSQL -->\n";

	/* Gebe result oder 0 zurck */
	if ($saEinArtikel)
	{	return $saEinArtikel;
	}
	else
	{	return "0";
	}
};

/******************************************************************************
 Function 	: FncArtikelArtSelectOption
 Arguments  : -
 Description: Holt alle Artikel-Arten und gibt sie als Select-option aus
 Returns  	: -
 Echos		: <option>-tag
 Templates 	: -
 Date		: 1999-04-07
 Author		: andreas kempf aka 'amalesh' <ak@living-source.com>
*******************************************************************************/

function FncArtikelArtSelectOption ()
{
	include ("inc/var_sql.inc.php3");

	$connectionID = FncOpenDatabase ();
	$svSQL = "select distinct Artikel_Art from $cfgTabArtikel";

	// Fhre SQL-Query aus
	$result = @mysql_query($svSQL,$connectionID);
	if (DEBUG) echo "\n<!-- debug: $svSQL -->\n";
	
	// Bilde option values
	$x=0;
	while ($saArtikelArt = @mysql_fetch_array($result))
	{	$strArtikelArt = $saArtikelArt["Artikel_Art"];
		echo "<OPTION VALUE=\"$strArtikelArt\">$strArtikelArt</option>\n";
		$x++;
	}

	if ($x == 0)	// Wenn keine options vorhanden
	{	echo "<OPTION VALUE=\"\">Keine Warengruppe vorhanden</option>";
	}
};

/******************************************************************************
 Function 	: FncArtikelAktionSelectOption
 Arguments  : -
 Description: Holt alle Artikel-Aktionen und gibt sie als Select-option aus
 Returns  	: -
 Echos		: <option>-tag
 Templates 	: -
 Date		: 1999-06-30
 Author		: andreas kempf aka 'amalesh' <ak@living-source.com>
*******************************************************************************/

function FncArtikelAktionSelectOption ()
{
	include ("inc/var_general.inc.php3");

	// Bilde option values
	$x=0;
	while ($x < count($cfgAktion))
	{	
		echo "<OPTION VALUE=\"$cfgAktion[$x]\">$cfgAktion[$x]</option>\n";
		$x++;
	}

};

/******************************************************************************
 Function 	: FncAddArtikelToBasket
 Arguments  : $VID, $nArtikel_Menge, $nArtikel_ID, $nPreis
 Description: Schreibt Artikel in den Basket, wenn der Kunde bestellt
 Returns  	: 1/0
 Echos		: -
 Templates 	: -
 Date		: 1999-04-08
 Author		: andreas kempf aka 'amalesh' <ak@living-source.com>
*******************************************************************************/

function FncAddArtikelToBasket ($VID, $nArtikel_Menge, $nArtikel_ID, $nPreis)
{
	
	// Wenn ID nicht 0, wird ausgefhrt
	if ($VID)
	{
		include ("inc/var_sql.inc.php3");
		$connectionID = FncOpenDatabase ();

		// berprfe, ob der Artikel schon existiert im Basket
		$svSQL 	= "select Artikel_Menge from $cfgTabBasket where visit_key = '$VID' and Artikel_ID = $nArtikel_ID";
		$result = @mysql_query( $svSQL,$connectionID);
		$nRows	= @mysql_num_rows($result);
		if (DEBUG) echo "\n<!-- debug: $svSQL, $result, $Rows -->\n";

		// Wenn ja, lese Menge, addiere und mache update
		if ($nRows)
		{	$nBAM = @mysql_result( $result, "Artikel_Menge");
			settype($nBAM,"integer");
			settype($nArtikel_Menge,"integer");				
			$nArtikel_Menge += $nBAM;
			FncUpdateBasketMenge ($VID, $nArtikel_ID, $nArtikel_Menge);
		}
		else
		{
			// Definiere, hole Variablen
			$nMwst = FncGetArtikelField ($nArtikel_ID, "mwst");
			
			// Tabellenfelder fr insertstring
			$saInsertField[0] = "Visit_key, ";
			$saInsertField[1] = "Artikel_Menge, ";
			$saInsertField[2] = "Artikel_ID, ";
			$saInsertField[3] = "MWST, ";
			$saInsertField[4] = "Preis";
	
			// Bilde 1. Teil des Insertstring
			$i=0;
			while ($i <= count($saInsertField))
			{	$svInsertField = $svInsertField	. $saInsertField[$i];
				$i++;
			}
	
			// Bilde kompletten Insert-String
			$svSQL = "insert into $cfgTabBasket ($svInsertField) values ('$VID', $nArtikel_Menge, $nArtikel_ID, $nMwst, $nPreis)";
			if (DEBUG) echo "\n<!-- debug: $svSQL -->\n";
	
			// Trage Datensatz ein
			$connectionID = FncOpenDatabase ();
			$result = @mysql_query( $svSQL, $connectionID);
		}
	}
	
	if ($result)
	{	return "1";
	}
	else
	{	return "0";
	}
};

/******************************************************************************
 Function 	: FncDeleteBasket
 Arguments  : $VID
 Description: Lscht alle Artikel eines Kunden aus den basket, wenn bestellt wurde
 Returns  	: 1/0
 Echos		: -
 Templates 	: -
 Date		: 1999-04-08
 Author		: andreas kempf aka 'amalesh' <ak@living-source.com>
*******************************************************************************/

function FncDeleteBasket ($VID)
{
	// Wenn ID nicht 0, wird ausgefhrt
	if ($VID)
	{
		include ("inc/var_sql.inc.php3");

		$connectionID = FncOpenDatabase ();
		$svSQL = "delete from $cfgTabBasket where visit_key='$VID'";
		if (DEBUG) echo "\n<!-- debug: $svSQL -->\n";

		$result = @mysql_query($svSQL,$connectionID);
	}
	
	if ($result)
	{	return "1";
	}
	else
	{	return "0";
	}

};

/******************************************************************************
 Function 	: FncDeleteBasketArtikel
 Arguments  : $VID, $nArtikel_ID
 Description: Lscht einen Artikel eines Kunden aus den basket
 Returns  	: 1/0
 Echos		: -
 Templates 	: -
 Date		: 1999-04-08
 Author		: andreas kempf aka 'amalesh' <ak@living-source.com>
*******************************************************************************/

function FncDeleteBasketArtikel ($VID, $nArtikel_ID)
{
	// Wenn ID nicht 0, wird ausgefhrt
	if ($VID)
	{
		include ("inc/var_sql.inc.php3");

		$connectionID = FncOpenDatabase ();
		$svSQL = "delete from $cfgTabBasket where visit_key='$VID' and Artikel_ID=$nArtikel_ID";
		if (DEBUG) echo "\n<!-- debug: $svSQL -->\n";

		$result = @mysql_query($svSQL,$connectionID);

	}	

	if ($result)
	{	return "1";
	}
	else
	{	return "0";
	}

};

/******************************************************************************
 Function 	: FncUpdateBasketMenge
 Arguments  : $VID, $nArtikel_ID, $nArtikel_Menge
 Description: ndert Artikel-Menge im Basket fr den Kunden
 Returns  	: 1/0
 Echos		: -
 Templates 	: -
 Date		: 1999-04-08
 Author		: andreas kempf aka 'amalesh' <ak@living-source.com>
*******************************************************************************/

function FncUpdateBasketMenge ($VID, $nArtikel_ID, $nArtikel_Menge)
{
	include ("inc/var_sql.inc.php3");
	$connectionID = FncOpenDatabase ();

	// Bilde kompletten Insert-String
	$svSQL = "update $cfgTabBasket set artikel_menge = $nArtikel_Menge where visit_key = '$VID' and Artikel_ID = $nArtikel_ID";
	if (DEBUG) echo "\n<!-- debug: $svSQL -->\n";

	// Trage Datensatz ein
	$result = @mysql_query( $svSQL, $connectionID);

	if ($result)
	{	return "1";
	}
	else
	{	return "0";
	}
};

/******************************************************************************
 Function 	: FncGetBasketSum
 Arguments  : $VID
 Description: Gibt preis-Summe der Artikel eines Kunden aus den basket
 Returns  	: $nSum
 Echos		: -
 Templates 	: -
 Date		: 1999-04-08
 Author		: andreas kempf aka 'amalesh' <ak@living-source.com>
*******************************************************************************/

function FncGetBasketSum ($VID)
{
	// Wenn ID nicht 0, wird ausgefhrt
	if ($VID)
	{
		include ("inc/var_sql.inc.php3");
		$connectionID = FncOpenDatabase ();

		// berechne Mengen und Preis
		$svSQL="select sum(artikel_menge * preis) as sum from $cfgTabBasket where visit_key='$VID'";
		if (DEBUG) echo "\n<!-- debug: $svSQL -->\n";
		$result = @mysql_query($svSQL,$connectionID);
		$nSum 	= @mysql_result( $result,0,"sum");
	}
	
	if ($nSum)
	{	settype ($nSum, "double");
		$nSum = sprintf ("%4.2f", $nSum);
		return $nSum;
	}
	else
	{	return "0";
	}

};

/******************************************************************************
 Function 	: FncAddArtikelToBestell
 Arguments  : $nKunden_ID, $nAnzahl, $nArtikel_ID, $nPreis, $nMwst
 Description: Schreibt Artikel in die bestell-Tabelle
 Returns  	: 1/0
 Echos		: -
 Templates 	: -
 Date		: 1999-04-14
 Author		: andreas kempf aka 'amalesh' <ak@living-source.com>
*******************************************************************************/

function FncAddArtikelToBestell ($nKunden_ID, $nAnzahl, $nArtikel_ID, $nPreis, $nMwst)
{
	// Wenn ID nicht 0, wird ausgefhrt
	if ($nKunden_ID != 0)
	{
		include ("inc/var_sql.inc.php3");
		$connectionID = FncOpenDatabase ();

		$svTimeStamp = Date ("YmdHis");
		
		// Tabellenfelder fr insertstring
		$saInsertField[0] = "Kunden_ID, ";
		$saInsertField[1] = "Artikel_Menge, ";
		$saInsertField[2] = "Artikel_ID, ";
		$saInsertField[3] = "MWST, ";
		$saInsertField[4] = "Preis";

		// Bilde 1. Teil des Insertstring
		$i=0;
		while ($i <= count($saInsertField))
		{	$svInsertField .= $saInsertField[$i];
			$i++;
		}

		// Bilde kompletten Insert-String
		$svSQL = "insert into $cfgTabBestell ($svInsertField) values ($nKunden_ID, $nAnzahl, $nArtikel_ID, $nMwst, $nPreis)";
		if (DEBUG) echo "\n<!-- debug: $svSQL -->\n";

		// Trage Datensatz ein
		$result = @mysql_query( $svSQL, $connectionID);

	}	

	if ($result)
	{	return "1";
	}
	else
	{	return "0";
	}


};

/******************************************************************************
 Function 	: FncBasketArtikelTabelle
 Arguments  : $VID
 Description: Holt alle Artikel aus dem Basket und der Artikel-DB und zeigt sie in einer Tabelle
 Returns  	: 1/0
 Echos		: -
 Templates 	: basket_table_head.tpl, basket_table_row.tpl, basket_table_end.tpl
 Date		: 1999-04-08
 Author		: andreas kempf aka 'amalesh' <ak@living-source.com>
*******************************************************************************/

function FncBasketArtikelTabelle ($VID)
{
	// Wenn ID nicht 0, wird ausgefhrt
	if ($VID)
	{
		include ("inc/var_sql.inc.php3");
		include ("inc/var_general.inc.php3");

		$connectionID = FncOpenDatabase ();
		
		// Hole zuerst die Artikel-IDs, Mengen und Preis
		$svSQL="select artikel_id, artikel_menge, preis, mwst from $cfgTabBasket where visit_key='$VID'";
		if (DEBUG) echo "\n<!-- debug: $svSQL -->\n";
		$result = @mysql_query($svSQL,$connectionID);

		$x=0;
		while ($saRow = @mysql_fetch_array($result))
		{	$saBasketArtikel_ID[$x] 	= $saRow["artikel_id"];
			$saBasketArtikel_Menge[$x] 	= $saRow["artikel_menge"];
			$saBasketArtikel_Preis[$x] 	= $saRow["preis"];
			$saBasketArtikel_Mwst[$x] 	= $saRow["mwst"];
			$x++;
		}

		// Wenn was gefunden wurde
		if ($x)
		{
			// Baue Tabelle und lade Template fr den Kopf der Tabelle
			include ("templates/basket_table_head.tpl");

			// Hole je gefundene Artikel-ID des Baskets einen Artikel aus der Artikel-DB
			$i=0;
			while ($i < count($saBasketArtikel_ID))
			{	$saEinArtikel = FncGetArtikel($saBasketArtikel_ID[$i]);

				// Weise Variable fr template zu
				$nID 			= $saEinArtikel["id"];
				$svArtikel_Art 	= $saEinArtikel["artikel_art"];
				$svArtikel_Nr 	= $saEinArtikel["artikel_nr"];
				$svArtikel_Name = $saEinArtikel["artikel_name"];
				$svBeschreibung = $saEinArtikel["beschreibung"];
				$nArtikel_Menge = $saBasketArtikel_Menge[$i];
				$nPreis 		= sprintf ("%4.2f", $saBasketArtikel_Preis[$i]);
		
				// Mache <a href>-tags fr die bilder
				$svImageComplete = FncImgTag ($saEinArtikel["image_small"], $saEinArtikel["image_big"], $svArtikel_Nr);
				
				// Formatiere
				$nGPreis 		= sprintf ("%4.2f", $nPreis * $nArtikel_Menge);

				// Lade Template fr die Tabellen-Zeile
				include ("templates/basket_table_row.tpl");
				
				// Berechne Mwst-Betrag, wenn alle EPreise netto sind
				$nMwst 					= $saBasketArtikel_Mwst[$i];
				$nMwstBetrag 			= $nArtikel_Menge * $nPreis * (($nMwst / 100) + 1) - $nArtikel_Menge * $nPreis;
				$nSumMwstWennNetto 		= $nSumMwstWennNetto + $nMwstBetrag;

				// Berechne Mwst-Betrag wenn alle Epreise brutto sind
				$nMwstAnteil 			= $nArtikel_Menge * $nPreis - ($nArtikel_Menge * $nPreis / (($nMwst / 100) + 1));
				$nSumMwstWennBrutto 	= $nSumMwstWennBrutto + $nMwstAnteil;

				/* Berechne Summen */
				$nSumme 	+= $nGPreis;
				
			$i++;
			}

			// Versandkostenanteil
			if ($nSumme <= $cfgVersKosLimit)
			{	
				include ("templates/basket_versandkosten.tpl");
				$nSumme 	+= $cfgVersandkosten;
				$nSumme 	 = sprintf ("%4.2f", $nSumme);
			}


			// Berechne Brutto/Netto-Summen
			$nSumWennNetto 	= $nSumme + $nSumMwstWennNetto;
			$nSumWennBrutto = $nSumme - $nSumMwstWennBrutto;

			// Formatiere Summen
			settype ($nSumMwstWennNetto, "double");
			settype ($nSumMwstWennBrutto, "double");
			$nSumMwstWennNetto 	= sprintf ("%4.2f", $nSumMwstWennNetto);
			$nSumMwstWennBrutto = sprintf ("%4.2f", $nSumMwstWennBrutto);
			$nSumWennBrutto 	= sprintf ("%4.2f", $nSumWennBrutto);
			$nSumWennNetto 		= sprintf ("%4.2f", $nSumWennNetto);
			$nSumme 			= sprintf ("%4.2f", $nSumme);

			include ("templates/basket_table_end.tpl");
		}
		else
		{	include ("inc/var_err.inc.php3");
			echo $svErrBasket00;
		}

	}

	// Gebe result oder 0 zurck
	if ($result != 0)
	{	return "1";
	}
	else
	{	return "0";
	}

};
/******************************************************************************
 Function 	: FncExecuteBestell
 Arguments  : $nKunden_ID, $VID, $svEmail
 Description: Holt alle Artikel aus dem Basket, schreibt sie in die bestell-Tab,
 			  schickt eine email an den auftragsbearbeiter und kunden, lscht basket
 Returns  	: $saBasketArtikel,0
 Echos		: -
 Templates 	: var_mail.inc.php3
 Date		: 1999-04-14
 Author		: andreas kempf aka 'amalesh' <ak@living-source.com>
*******************************************************************************/

function FncExecuteBestell ($nKunden_ID, $VID, $svEmail)
{
	// Wenn ID nicht 0, wird ausgefhrt
	if ($VID)
	{
		include ("inc/var_sql.inc.php3");

		$connectionID = FncOpenDatabase ();

		// Hole zuerst die Artikel-IDs und die Mengen aus dem Basket
		$svSQL="select artikel_id, artikel_menge, preis, mwst from $cfgTabBasket where visit_key='$VID'";
		if (DEBUG) echo "\n<!-- debug: $svSQL -->\n";
		$result = @mysql_query($svSQL,$connectionID);
		
		$x=0;
		while ($saRow = @mysql_fetch_array($result))
		{	$saBasketArtikel_ID 	= $saRow["artikel_id"];
			$saBasketArtikel_Menge 	= $saRow["artikel_menge"];
			$saBasketArtikel_Preis 	= $saRow["preis"];
			$saBasketArtikel_Mwst 	= $saRow["mwst"];

			FncAddArtikelToBestell ($nKunden_ID, $saBasketArtikel_Menge, $saBasketArtikel_ID, $saBasketArtikel_Preis, $saBasketArtikel_Mwst);

			$saEinArtikel = FncGetArtikel($saBasketArtikel_ID);

			// Weise Variable fr template zu
			$nID 			= $saEinArtikel["id"];
			$svArtikel_Art 	= $saEinArtikel["artikel_art"];
			$svArtikel_Nr 	= $saEinArtikel["artikel_nr"];
			$svArtikel_Name = $saEinArtikel["artikel_name"];
			$svBeschreibung = nl2br($saEinArtikel["beschreibung"]);
			$nMenge 		= $saBasketArtikel_Menge;
			$nPreis 		= sprintf ("%4.2f", $saBasketArtikel_Preis);
			$nGPreis 		= sprintf ("%4.2f", $nMenge * $nPreis);

			include ("inc/var_mail.inc.php3");
			$svMailText .= $svMailArtikelZeile;

			$x++;
		}

		// Hole verschiedene Variablen fr das Email
		$nSum 		= FncGetBasketSum ($VID);
		$svAnrede 	= FncGetAdressField ($nKunden_ID, "anrede");
		$svNachname = FncGetAdressField ($nKunden_ID, "nachname");
		$svStrasse 	= FncGetAdressField ($nKunden_ID, "strasse_nr");
		$svPLZ 		= FncGetAdressField ($nKunden_ID, "plz");
		$svOrt 		= FncGetAdressField ($nKunden_ID, "ort");
		$svBestellart = FncGetAdressField ($nKunden_ID, "bestellart");
		include ("inc/var_mail.inc.php3");
		
		// Schreibe Email an besteller und auftragsbearbeitung
		$svMailText = $svMailKopf. $svMailText . $svMailArtikelSum . $svMailZahlung . $svMailEnd;
		mail("$svEmail $svANEmail", "Online-Bestellung", $svMailText, "From: $svANEmail");

		// Lsche den Basket
		FncDeleteBasket ($VID);
	
	}

	// Gebe result oder 0 zurck
	if ($result)
	{	return $saBasketArtikel;
	}
	else
	{	return "0";
	}
};

/******************************************************************************
 Function 	: FncGetBasketDate
 Arguments  : $VID
 Description: Holt Datum des letzten artikels fr einen Kunden aus Basket
 Returns  	: $svValue,0
 Echos		: -
 Templates 	: -
 Date		: 1999-04-14
 Author		: andreas kempf aka 'amalesh' <ak@living-source.com>
*******************************************************************************/

function FncGetBasketDate ($VID)
{
	// Wenn ID nicht 0, wird ausgefhrt
	if ($VID)
	{
		include ("inc/var_sql.inc.php3");

		$connectionID = FncOpenDatabase ();
		$svSQL = "select timestamp from $cfgTabBasket where visit_key = '$VID'";
		if (DEBUG) echo "\n<!-- debug: $svSQL -->\n";

		// Fhre SQL-Query aus
		$result = @mysql_query($svSQL,$connectionID);

		while ($saRow = @mysql_fetch_array($result))
		{	$svTimestamp = $saRow["timestamp"];
		}

		// bersetze timestamp in Datum
		$svValue = FncChangeTimestamp($svTimestamp, "YYYY-MM-DD");

	}
	
	// Gebe result oder 0 aus und zurck
	if ($result)
	{	return $svValue;
	}
	else
	{	return "0";
	}
};

/******************************************************************************
 Function 	: FncExistKunde
 Arguments  : $nKunden_ID
 Description: Prft, ob der Kunden schon in den adressen eingetragen ist.
 Returns  	: 1/0
 Echos		: -
 Templates 	: -
 Date		: 1999-04-09
 Author		: andreas kempf aka 'amalesh' <ak@living-source.com>
*******************************************************************************/

function FncExistKunde ($nKunden_ID)
{
	// Wenn ID nicht 0, wird ausgefhrt
	if ($nKunden_ID)
	{
		include ("inc/var_sql.inc.php3");

		$connectionID = FncOpenDatabase ();
		$svSQL = "select ID from $cfgTabAdressen where ID = $nKunden_ID";
		if (DEBUG) echo "\n<!-- debug: $svSQL -->\n";

		// Fhre SQL-Query aus
		$result = @mysql_query($svSQL,$connectionID);
		$svValue = @mysql_result($result, 0,"ID");

	}
	
	// Gebe result oder 0 aus und zurck
	if ($svValue)
	{	return "1";
	}
	else
	{	return "0";
	}


};

/******************************************************************************
 Function 	: FncSQLSearchString ($svValue="0",$svArtikelArt="0",$svArtikelAktion="0") 
 Arguments  : $svValue 			= freier Suchbegriff
 			  $svArtikelArt 	= Die gewnschte Artikel-Art
			  $svArtikelAktion	= Die gesuchte Aktion
 Description: Bildet den zweiten teil einer where-bedingung
 Returns  	: string
 Echos		: -
 Templates 	: -
 Date		: 1999-07-28
 Author		: andreas kempf
*******************************************************************************/

function FncSQLSearchString ($svValue="0",$svArtikelArt="0",$svAktion="0")
{

	// Mgliche such- und sortierfelder
	include ("inc/var_sql.inc.php3");

	$svSQL .= " where 1=1 ";		// Am anfang der where-clause
	
	// berprfe Artikel-Art
	if ($svArtikelArt)
	{	$svSQL .= " and Artikel_Art='$svArtikelArt'";
	}
	
	if ($svAktion)			// Wenn Aktion
	{	$svAktion = ereg_replace(" ","", $svAktion); // Nehme leerzeichen raus
		$saAktion = explode(",", $svAktion);		 // Trenne einzelne eintrge nach komma

		$x=0;
		while ($x < count($saAktion)) // fr jede Aktion
		{	$svSQL = $svSQL . " and Artikel_Aktion like '%$saAktion[$x]%'";
			$x++;
		}
	}		

	if ($svValue)	// Wenn suchbegriff
	{	
		$svSQL .= " and (";			// Klammer auf
		
		for ($x=0;$x<count($cfgSuchFeld);$x++)
		{	// Beim ersten mal kein "or" davor
			if ($x==0)
			{	$svSQL .= " " . $cfgSuchFeld[$x] . " like '%$svValue%'";
			}
			else
			{	$svSQL .= " or " . $cfgSuchFeld[$x] . " like '%$svValue%'";
			}
		}	
		// Klammer zu
		$svSQL .= ")";
	}

	if (DEBUG) echo "\n<!-- debug: $svSQL -->";

	return $svSQL;
}

/******************************************************************************
 Function 	: FncShopArtikelTabelle
 Arguments  : $VID, $svArtikelArt, $svPreisTyp, $nPos="0", $svAktion = "0", $svValue="0"
 Description: Stellt alle Artikel als Tabelle dar fr den Kunden
 Returns  	: 1/0
 Echos		: -
 Templates 	: artikel_table_head.tpl, artikel_table_row.tpl, artikel_table_end.tpl
 Date		: 1999-06-25
 Author		: andreas kempf aka 'amalesh' <ak@living-source.com>
*******************************************************************************/

function FncShopArtikelTabelle ($VID, $svArtikelArt, $svPreisTyp, $svAktion = "0", $svValue="0")
{
	include ("inc/var_sql.inc.php3");
	include ("inc/var_general.inc.php3");

	$connectionID = FncOpenDatabase ();

	$svArtikelArt = urldecode($svArtikelArt);

	// Bilde SQL-Sring
	$svSQL 		= "select $cfgTabArtikelFelder from $cfgTabArtikel";			// Start

	// Sortierung
	if ($cfgSortOrder)	// Wenn angegeben
	{	$svSQLOrder = " order by $cfgSortOrder";
	}

	$svSQL 	.= FncSQLSearchString ($svValue,$svArtikelArt,$svAktion);	// Search
	
	if (DEBUG) echo "\n<!-- debug: $svSQL -->\n";

	// Fhre SQL-Query aus
	$result = @mysql_query($svSQL,$connectionID);
	$nZeilen= @mysql_num_rows($result);


	$svArtikelArt = urlencode($svArtikelArt);

	if ($strSQLWhere != " where 1=1 ")
			include ("templates/search_headline.tpl");

	// Baue Tabelle und lade Template fr den Kopf der Tabelle
	include ("templates/artikel_table_head.tpl");
	
	// Lese Artikel aus
	$x=0;
	while ($saEinArtikel = @mysql_fetch_array($result))
	{	
		// Weise Variable fr template zu
		$nID 			= $saEinArtikel["id"];
		$svArtikel_Art 	= $saEinArtikel["artikel_art"];
		$svArtikel_Nr 	= $saEinArtikel["artikel_nr"];
		$svArtikel_Name = $saEinArtikel["artikel_name"];
		$svBeschreibung = nl2br($saEinArtikel["beschreibung"]);
		
		// Bestimme gewnschten Preis
		$svPreisFeld = "preis_" . strtolower($svPreisTyp);
		$nPreis 	 = sprintf ("%4.2f", $saEinArtikel[$svPreisFeld]);
	
		// Mache <a href>-tags fr die bilder
		$svImageComplete = FncImgTag ($saEinArtikel["image_small"], $saEinArtikel["image_big"], $svArtikel_Nr);


		// Debug-Info ---------------------------------------------------------------------------------
		if (DEBUG) 
		{	echo "\n<!-- debug: $nID, $svArtikel_Art, $svArtikel_Nr, $svArtikel_Name, $svBeschreibung, $svPreisFeld, $nEuroPreis -->\n";
			$z=0;
			while ($z < count($saEinArtikel))
			{	echo "<!-- Array: $saEinArtikel[$z] -->\n";
				$z++;
			}
		}


		// Lade Template fr die Zeile
		include ("templates/artikel_table_row.tpl");
		$x++;
	}
	include ("templates/artikel_table_end.tpl");

	// Gebe result oder 0 zurck
	if ($result)
	{	return "1";
	}
	else
	{	return "0";
	}

};

/******************************************************************************
 Function 	: FncShopEinArtikel
 Arguments  : $VID, $svArtikel_Nr, $svPreisTyp = "A"
 Description: Stellt einen Artikel dar fr den Kunden
 Returns  	: 1/0
 Echos		: -
 Templates 	: artikel.tpl
 Date		: 1999-04-15
 Author		: andreas kempf aka 'amalesh' <ak@living-source.com>
*******************************************************************************/

function FncShopEinArtikel ($VID, $svArtikel_Nr, $svPreisTyp = "A")
{
	include ("inc/var_general.inc.php3");

	$nArtikel_ID = FncGetArtikelID ($svArtikel_Nr);
	$saEinArtikel= FncGetArtikel ($nArtikel_ID);

	// Variablen zuweisen
	$nID 			= $saEinArtikel["id"];
	$svArtikel_Art 	= $saEinArtikel["artikel_art"];
	$svArtikel_Nr 	= $saEinArtikel["artikel_nr"];
	$svArtikel_Name = $saEinArtikel["artikel_name"];
	$svBeschreibung = nl2br($saEinArtikel["beschreibung"]);

	// Bestimme gewnschten Preis
	$svPreisFeld= "preis_" . strtolower($svPreisTyp);
	$nPreis 	= sprintf ("%4.2f", $saEinArtikel[$svPreisFeld]);

	// Mache <a href>-tags fr die bilder
	$svImageComplete = FncImgTag ($saEinArtikel["image_small"], $saEinArtikel["image_big"], $svArtikel_Nr);

	include ("templates/artikel.tpl");
};
?>