<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 3.2 Final//EN">

<HTML>
<HEAD>
	<TITLE>Installation Caupo Shop</TITLE>
</HEAD>

<BODY bgcolor="#ffffff">

<?
/******************************************************************************

Diese Datei bernimmt die komplette Installation

Author   	: Andreas Kempf
Datum		: 1999-05-19
Version 	: 2.0

******************************************************************************/
?>

<h1>Installationsanleitung Caupo Shop 1.0</h1>
<hr noshade>
<h3>Guten Tag und herzlich willkommen bei der Installation des Caupo Shops!</h3><br>
<hr noshade>
<h3>Technische Voraussetzungen</h3>
<ul>
	<li>PHP3 ab Version 3.02
	<li>MySQL ab Version 3.21.23
</ul>

Die Installation vollzieht sich in folgenden Schritten:
<ol type="1">
	<a href="#1"><li></a>Anlegen von Verzeichnissen
	<a href="#2"><li></a>Extrahieren der Datei caupo.zip in die vorgesehenen Verzeichnisse
	<a href="#3"><li></a>Setzen der Rechte auf bestimmte Verzeichnisse
	<a href="#4"><li></a>Eintrag von System-Konfigurations-Variablen
	<a href="#5"><li></a>Anlegen der Tabellen
</ol>
<br>
In diesem Installationsscripts werden die Tabellen in der Datenbank automatisch angelegt,
die Schritte 1-4 sind von Ihrem Systemadministrator durchzufhren.<br>
<br>
<a name="1">&nbsp;</a>
<hr noshade>
<h2>Im einzelnen:</h2>
<h3>1. Anlegen von Verzeichnissen</h3>
Fr den Caupo Shop mu ein Haupt-Verzeichnis angelegt werden<br>
Die Bezeichnung ist frei whlbar, z.B.: /shop<br>
<br>
Es mssen dann drei Unterverzeichnisse angelegt werden:
<ul>
	<li>/images
	<li>/inc
	<li>/templates
</ul>
<a name="2">&nbsp;</a>
<hr noshade>
<h3>2. Extrahieren der Zip-Datei</h3>
Die Zip-Datei beinhaltet relative Pfad-Angaben, das extrahieren sollte in die zuvor angelegten Verzeichnisse erfolgen.<br>
<br>
Der Inhalt der Verzeichnisse:
<table cellspacing="5">
	<tr><td><strong>Verzeichnis</strong></td><td><strong>Beschreibung</strong></td></tr>
	<tr><td>/shop           </td><td>Startpage, Artikel-Darstellung, Warenkorb etc. als PHP3-Dateien</td></tr>
	<tr><td>/shop/images    </td><td>Grafiken</td></tr>
	<tr><td>/shop/inc       </td><td>Funktionsbibliotheken und System-Variablen mit der Endung .inc.php3</td></tr>
	<tr><td>/shop/templates </td><td>Vorlagen fr Artikel, Email etc. mit der Endung .tpl</td></tr>
</table>

<a name="3">&nbsp;</a>
<hr noshade>
<h3>3. Setzen der Rechte auf bestimmte Verzeichnisse</h3>
Auf die Verzeichnisse
<ul>
	<li>/images
	<li>/templates
</ul>
mssen per chown die Rechte auf den User "nobody" gesetzt werden. Nur so ist es mglich,
Grafiken ber den Browser hochzuladen und die Vorlagen online zu verndern.<br>
<br>
Die anderen Verzeichnis-Rechte knnen bestehen bleiben<br>
<br>

<a name="4">&nbsp;</a>
<hr noshade>
<h3>4. Eintrag von System-Konfigurations-Variablen</h3>

In der Datei <strong>/inc/var_general.inc.php3</strong> sind folgende Eintrge zu machen:<br>
<br>

<table border="1" cellpadding="1" cellspacing="0">
	<tr><td><strong>Eintrag</strong>  </td><td><strong>Beschreibung</strong></td></tr>
	<tr><td>$cfgShopImagePath = "/home/httpd/html/kunden/shop/images/";	</td><td>Zielpfad fr die Grafik zum Upload</td></tr>
	<tr><td>$cfgCookieExpire = "3600";									</td><td>Gltigkeitsdauer des Cookies in Sekunden. Ist nicht zwingend und wird nur bei Absturz des Browsers bentigt.</td></tr>
	<tr><td>$cfgAdminName = "gast";										</td><td>Benutzername des Administrators (fr Artikel/Adressen/Templates)</td></tr>
	<tr><td>$cfgAdminPw = "gast";              							</td><td>Password des Admin</td></tr>
	<tr><td>$cfgVersandkosten	= "14.50";									</td><td>Versandkosten (DM-Betrge!)</td></tr>
	<tr><td>$cfgVersKosLimit	= "99.00";									</td><td>Bis zu welchem Betrag werden diese aufgeschlagen?</td></tr>
	<tr><td>$cfgNachnahme		= "9.50";									</td><td>Nachnahme</td></tr>
	<tr><td>$cfgAktion		= array("WSV","SSV","Sonderaktion");		</td><td>Mgliche Aktionen fr die Artikel. Daraus wird automatisch die Select-Box gebiildet</td></tr>
</table>

</table>
<br>
<br>
In der Datei <strong>/inc/var_sql.inc.php3</strong> sind folgende Eintrge zu machen.<br>
<br>
Eintrge fr die MySQL-Infos:
<table border="1" cellpadding="1" cellspacing="0">
	<tr><td><strong>MySQL-Eintrag</strong>  </td><td><strong>Beschreibung</strong></td></tr>
	<tr><td>$cfgSQLDataSource = "host";      </td><td>Datenquelle</td></tr>
	<tr><td>$cfgSQLDataBase = "database";    </td><td>Datenbank <font size="-2">(mu eine existierende sein!)</font></td></tr>
	<tr><td>$cfgSQLUsername = "user";            </td><td>Benutzername</td></tr>
	<tr><td>$cfgSQLPasswd = "password";              </td><td>Password</td></tr>
	<tr><td><strong>Tabellennamen</strong>				</td><td>&nbsp;</td></tr>
	<tr><td>$cfgTabAdressen = "shop_kunden";         </td><td>Adressen</td></tr>
	<tr><td>$cfgTabArtikel = "shop_artikel";         </td><td>Artikel</td></tr>
	<tr><td>$cfgTabBasket = "shop_basket";           </td><td>Warenkorb</td></tr>
	<tr><td>$cfgTabBestell = "shop_bestellungen";    </td><td>Bestellungen</td></tr>
	<tr><td>$cfgTabVisit = "shop_visit";             </td><td>Tabelle fr generische Visit-Nummer</td></tr>
	<tr><td>$cfgMaxRows = "5";				</td><td>Limit fr die Darstellung von Artikeln pro Seite</td></tr>
	<tr><td>$cfgSuchFeld = array ("artikel_art", "artikel_name", "artikel_nr", "beschreibung", "preis_a");</td><td>Felder, in denen ein suchbegriff gefunden werden soll</td></tr>
	<tr><td>$cfgTabArtikelFelder = "id, artikel_art, artikel_nr, artikel_name, beschreibung, artikel_aktion, Image_Small, image_big, preis_a, preis_b, preis_c, preis_d, preis_e, mwst, timestamp";</td><td>Felder, die bei der Admin-Liste der Artikel angezeigt werden sollen</td></tr>
</table>

<strong>Hinweise:<br> Jeder Shop-Besitzer bentigt eigene Tabellen-Namen!</strong>
<br>Bitte ndern Sie nur die Begriffe innerhalb der Anfhrungszeichen!
<a name="5">&nbsp;</a>
<hr noshade>
<h3>5. Anlegen der Tabellen</h3>
Sobald die obigen Schritte durchgefhrt wurden, knnen die Tabellen in der Datenbank angelegt werden.<br>
<br>
Sollten Sie noch keine Datenbank (wie unter $cfgSQLDataBase angegeben) angelegt haben, fhren Sie das bitte jetzt manuell aus (CREATE DATABASE...).
<br>
<br>
Auf der folgenden Seite knnen Sie die Datenbank-Tabellen anlegen lassen.<br>
<br>
Es wird zunchst berprft, ob die Tabellen bereits existieren. Wenn nicht, werden diese angelegt<br>
<form action="install_sql.php3">
	<input type="Hidden" name="action" value="SQL_create">
	<input type="submit" value="Datenbank-Tabellen anlegen">
</form>
<br>
<br>
<br>
<br>
<br>
<br>
<br>
<font size="-3">Copyright: <a href="http://www.caupo.de/shop/licence.txt">Siehe Lizenzbedingungen</a></font>
<br>
<br>
<br>
<br>
<br>
<br>

</BODY>
</HTML>