<?

/******************************************************************************

Diese Datei installiert die SQL-Tabellen

Author   	: Andreas Kempf
Datum		: 1999-04-21

Zu Beginn wird mit $svTitle der Titel fr die Page definiert. Dieser Titel wird
dann in dem template "head.tpl" verwendet. Ebenso kann per <? echo $svTitle ?>
der Titel nochmals nach dem Body angezeigt werden

******************************************************************************/

/* Lade allgemeinen Dateikopf */
$svTitle = "SQL-Tabellen fr den Shop";
Header("Cache-control:  no-cache"); 
include ("templates/head.tpl");
echo "<meta http-equiv=\"Expires\" content=\"0\">";
echo "</head>";
include ("templates/body.tpl");
include ("inc/functions_shop.inc.php3");

?>	

<h1><? echo $svTitle ?></h1>
<hr noshade>
<br>
<?

/* Falls jemand die install_sql direkt aufruft. Ein redirect wre hier stattdessen auch denkbar */
if ($action == "SQL_create")
{	$nDirs[0] = file_exists("inc/var_sql.inc.php3");
	$nDirs[1] = file_exists("templates/body.tpl");

	/* berprfe anhand zweier Beispieldateien, ob Installation durchgefhrt werden kann */
	if ($nDirs[0] == 0 || $nDirs[1] == 0)
	{	echo "Installation kann nicht ausgefhrt werden.<br>\n";
		echo "Es sind entweder die Verzeichnisse nicht angelegt oder Dateien fehlen\n"; 
	}
	else
	{	$bInstOk = 1;
	}
}

if ($bInstOk == 1)
{	
	include ("inc/var_sql.inc.php3");

	$connectionID = FncOpenDatabase ();	

	/* Tabellen werden in ein Array gepackt */
	$saTab[0] = $cfgTabAdressen;
	$saTab[1] = $cfgTabArtikel;
	$saTab[2] = $cfgTabBasket;
	$saTab[3] = $cfgTabBestell;
	$saTab[4] = $cfgTabVisit;

	/* berprfe, ob Tabellen existieren */
	$result = mysql_list_tables($cfgSQLDataBase,$connectionID);
	$i = 0;
	while ($i < mysql_num_rows ($result))
	{   $saTabName[$i] = mysql_tablename ($result, $i);
		$j = 0;
		while ($j < count($saTab))
		{   if ($saTabName[$i] == $saTab[$j])
			{	echo "Tabelle $saTab[$j] existiert schon!<br>\n";
				$nTabOk = 0;
			}
			$j++;
		}
	    $i++;
	}

	/* Wenn die Tabellen nicht existieren, kann angelegt werden */
	if (1==1)
	{	$saSQL[0] =	"create table " . $cfgTabAdressen . " 
					(
					id integer not null default '0' auto_increment,
					anrede varchar(5),
					vorname varchar(30),
					nachname varchar(30),
					firma varchar(30),
					strasse_nr varchar(30),
					plz varchar(10),
					ort varchar(30),
					land varchar(30),
					telefon varchar(30),
					telefax varchar (30),
					email varchar(50),
					kunden_nr varchar(30),
					la_anrede varchar(5),
					la_vorname varchar(30),
					la_nachname varchar(30),
					la_firma varchar(30),    
					la_strasse_nr varchar(30),
					la_plz varchar(10),
					la_ort varchar(30),
					la_land varchar(30),
					la_telefon varchar(30),
					la_telefax varchar (30),
					la_email varchar(50),
					kreditk_typ varchar(30),
					kreditk_nr varchar(30),
					kreditk_gueltdate varchar(16),
					kreditk_gueltcheck int(1),
					bank varchar(30),
					blz varchar(10),
					konto_nr varchar(10),
					bestellart varchar(30),   
					password varchar(10),
					timestamp timestamp,
					primary key (id)
					)";
	
		$saSQL[1] = "create table ". $cfgTabArtikel ." 
					(
					id integer not null default '0' auto_increment, 
					artikel_art varchar(30),
					artikel_nr varchar(30),
					artikel_name varchar(30),
					beschreibung text,
					artikel_aktion varchar (255),
					image_small varchar(60),
					image_big varchar(60),
					preis_a decimal (12,2),
					preis_b decimal (12,2),
					preis_c decimal (12,2),
					preis_d decimal (12,2),
					preis_e decimal (12,2),
					mwst decimal (5,2),
					timestamp timestamp,
					primary key (id)
					)";
	
		$saSQL[2] = "create table ". $cfgTabBasket ." 
					(
					id integer not null default '0' auto_increment,
					visit_key char(20),
					artikel_menge integer,
					artikel_id integer,
					timestamp timestamp,
					mwst decimal (5,2),
					preis decimal (12,2),
					primary key (id)
					)";
		
	
		$saSQL[3] = "create table " . $cfgTabBestell . " 
					(
					id integer not null default '0' auto_increment,
					artikel_menge integer,
					kunden_id integer,
					artikel_id integer,
					timestamp timestamp,
					mwst decimal (5,2),
					preis decimal (12,2),
					primary key (id)
					)";
		
		$saSQL[4] = "create table " . $cfgTabVisit . " 
					(
					id integer not null default '0' auto_increment,
					kunden_id integer,
					timestamp timestamp,
					visit_key char(20),
					primary key (id)
					)";
	
		$connectionID = FncOpenDatabase ();	
		$x=0;
		while ($x < count($saSQL))
		{
			/* Fhre SQL-Query aus */
			echo "<!-- $saSQL[$x] -->";
			$result = mysql_query($saSQL[$x],$connectionID);
			if ($result)
			{	echo "$saTab[$x] wurde erfolgreich angelegt<br>\n";
			}
			$x++;

		}
	}
}
?>
</BODY>
</HTML>
